
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	258
#define	FROM	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	SIGNED	264
#define	UNSIGNED	265
#define	LONG	266
#define	SHORT	267
#define	INT	268
#define	FLOAT	269
#define	DOUBLE	270
#define	CHAR	271
#define	FIRST	272
#define	LAST	273
#define	ONERROR	274
#define	TOKEN	275
#define	NUMBER	276
#define	TYPETOKEN	277
#define	CCODE	278
#define	HCODE	279
#define	PUBLIC	280
#define	PRIVATE	281
#define	ARGUMENT	282
#define	VIRTUAL	283
#define	SIGNAL	284
#define	OVERRIDE	285

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"

#define _(x) (x)
	
extern char *filename;
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_this = FALSE;

static GList *gtktypes = NULL;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static void
push_variable(char *name, int scope)
{
	Node *var;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	var = new_variable(scope,type,name);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no, int ccode_line)
{
	Node *node;
	Type *type;
       
	if(scope!=INIT_METHOD && scope!=CLASS_INIT_METHOD) {
		type = typestack->data;
		typestack = g_list_remove(typestack,typestack->data);
	} else {
		type = (Type *)new_type(0,g_strdup("void"));
	}
	
	node = new_method(scope,type,oid,gtktypes,id,funcargs,
			  onerror,cbuf,line_no,ccode_line);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name)
{
	Node *node;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_this(char *this)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype));
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,this,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 158 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		190
#define	YYFLAG		-32768
#define	YYNTBASE	45

#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 69)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    43,     2,     2,     2,     2,     2,     2,    34,
    35,    37,     2,    38,    44,     2,     2,     2,    40,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    33,    42,
    39,    41,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    31,    36,    32,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    15,    18,    20,    22,    27,
    32,    35,    38,    41,    43,    45,    47,    52,    57,    69,
    78,    82,    83,    87,    89,    91,    94,    97,   100,   102,
   105,   108,   110,   112,   114,   116,   119,   121,   123,   126,
   128,   131,   133,   135,   137,   139,   141,   144,   146,   151,
   155,   157,   169,   180,   191,   201,   211,   220,   233,   243,
   253,   259,   266,   269,   273,   276,   277,   279,   281,   285,
   287,   291,   293,   296,   303,   306,   308,   310,   313,   316,
   320,   324,   328,   332,   334,   337
};

static const short yyrhs[] = {    46,
    47,    46,     0,    47,    46,     0,    46,    47,     0,    47,
     0,    46,    23,     0,    46,    24,     0,    23,     0,    24,
     0,    48,    31,    49,    32,     0,     3,    22,     4,    22,
     0,    49,    61,     0,    49,    50,     0,    49,    51,     0,
    61,     0,    50,     0,    51,     0,    25,    54,    20,    33,
     0,    26,    54,    20,    33,     0,    27,    52,    20,    20,
    20,    31,    23,    20,    31,    23,    33,     0,    27,    52,
    20,    20,    20,    31,    23,    33,     0,    34,    53,    35,
     0,     0,    20,    36,    53,     0,    20,     0,    55,     0,
    55,    58,     0,    10,    56,     0,     9,    56,     0,    56,
     0,    10,    16,     0,     9,    16,     0,    16,     0,    15,
     0,    14,     0,    20,     0,    57,    20,     0,    22,     0,
     5,     0,    11,    13,     0,    11,     0,    12,    13,     0,
    12,     0,    13,     0,     8,     0,     7,     0,     6,     0,
    37,    58,     0,    37,     0,    20,    34,    60,    35,     0,
    60,    38,    20,     0,    20,     0,    29,    20,    59,    54,
    20,    34,    63,    35,    62,    31,    23,     0,    29,    20,
    59,    54,    20,    34,    63,    35,    62,    33,     0,    29,
    59,    54,    20,    34,    63,    35,    62,    31,    23,     0,
    29,    59,    54,    20,    34,    63,    35,    62,    33,     0,
    28,    54,    20,    34,    63,    35,    62,    31,    23,     0,
    28,    54,    20,    34,    63,    35,    62,    33,     0,    30,
    34,    22,    35,    54,    20,    34,    63,    35,    62,    31,
    23,     0,    25,    54,    20,    34,    63,    35,    62,    31,
    23,     0,    26,    54,    20,    34,    63,    35,    62,    31,
    23,     0,    20,    34,    20,    35,    33,     0,    20,    34,
    20,    35,    31,    23,     0,    19,    68,     0,    19,    31,
    23,     0,    39,    40,     0,     0,     5,     0,    20,     0,
    20,    38,    64,     0,    64,     0,    64,    38,    65,     0,
    65,     0,    54,    20,     0,    54,    20,    34,    20,    66,
    35,     0,    66,    67,     0,    67,     0,    20,     0,    41,
    68,     0,    42,    68,     0,    41,    39,    68,     0,    42,
    39,    68,     0,    39,    39,    68,     0,    43,    39,    68,
     0,    21,     0,    44,    21,     0,    20,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   176,   177,   178,   179,   182,   186,   190,   194,   200,   207,
   212,   213,   214,   215,   216,   217,   220,   223,   227,   254,
   278,   279,   282,   285,   291,   295,   302,   305,   308,   311,
   314,   317,   320,   323,   326,   329,   333,   336,   341,   344,
   347,   350,   353,   358,   361,   364,   369,   370,   373,   378,
   381,   387,   408,   428,   437,   446,   450,   454,   458,   462,
   466,   482,   503,   504,   508,   509,   514,   515,   525,   535,
   538,   539,   542,   545,   555,   556,   559,   572,   576,   580,
   584,   588,   592,   598,   599,   603
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","VOID","STRUCT","UNION","ENUM","SIGNED","UNSIGNED","LONG","SHORT","INT",
"FLOAT","DOUBLE","CHAR","FIRST","LAST","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"CCODE","HCODE","PUBLIC","PRIVATE","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE",
"'{'","'}'","';'","'('","')'","'|'","'*'","','","'='","'1'","'>'","'<'","'!'",
"'-'","prog","ccodes","class","classdec","classcode","variable","argument","argflags",
"flaglist","type","type1","integer","tspecifier","stars","sigtype","tokenlist",
"method","onerror","funcargs","arglist","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    45,    45,    45,    45,    46,    46,    46,    46,    47,    48,
    49,    49,    49,    49,    49,    49,    50,    50,    51,    51,
    52,    52,    53,    53,    54,    54,    55,    55,    55,    55,
    55,    55,    55,    55,    55,    55,    55,    55,    56,    56,
    56,    56,    56,    57,    57,    57,    58,    58,    59,    60,
    60,    61,    61,    61,    61,    61,    61,    61,    61,    61,
    61,    61,    62,    62,    62,    62,    63,    63,    63,    63,
    64,    64,    65,    65,    66,    66,    67,    67,    67,    67,
    67,    67,    67,    68,    68,    68
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     2,     2,     1,     1,     4,     4,
     2,     2,     2,     1,     1,     1,     4,     4,    11,     8,
     3,     0,     3,     1,     1,     2,     2,     2,     1,     2,
     2,     1,     1,     1,     1,     2,     1,     1,     2,     1,
     2,     1,     1,     1,     1,     1,     2,     1,     4,     3,
     1,    11,    10,    10,     9,     9,     8,    12,     9,     9,
     5,     6,     2,     3,     2,     0,     1,     1,     3,     1,
     3,     1,     2,     6,     2,     1,     1,     2,     2,     3,
     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     7,     8,     0,     4,     0,     0,     5,     6,     3,
     2,     0,     0,     1,     0,     0,     0,    22,     0,     0,
     0,     0,    15,    16,    14,    10,     0,    38,    46,    45,
    44,     0,     0,    40,    42,    43,    34,    33,    32,    35,
    37,     0,    25,    29,     0,     0,     0,     0,     0,     0,
     0,     0,     9,    12,    13,    11,     0,    31,    28,    30,
    27,    39,    41,     0,    48,    26,    36,     0,    24,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    17,     0,
    47,    18,     0,     0,    21,     0,     0,    51,     0,     0,
     0,     0,     0,    61,    38,    35,     0,     0,    70,    72,
     0,    23,     0,     0,    49,     0,     0,     0,     0,    62,
     0,    73,    66,     0,    66,     0,    66,    50,     0,     0,
     0,    69,     0,     0,     0,     0,    71,     0,     0,     0,
     0,    66,     0,     0,    86,    84,     0,     0,    63,    65,
     0,     0,     0,    20,     0,    57,    66,     0,     0,    77,
     0,     0,     0,     0,     0,    76,    64,    85,    59,    60,
     0,    56,     0,     0,    55,    66,     0,     0,    78,     0,
    79,     0,    74,    75,     0,     0,    53,    54,     0,    82,
    80,    81,    83,    19,    52,     0,    58,     0,     0,     0
};

static const short yydefgoto[] = {   188,
     4,     5,     6,    22,    23,    24,    48,    70,    97,    43,
    44,    45,    66,    51,    89,    25,   126,    98,    99,   100,
   155,   156,   139
};

static const short yypact[] = {    33,
    11,-32768,-32768,    44,    51,   -19,    18,-32768,-32768,    51,
    79,    52,    61,    79,     4,    85,    85,    70,    85,     9,
    72,   101,-32768,-32768,-32768,-32768,    32,-32768,-32768,-32768,
-32768,   123,   129,   107,   109,-32768,-32768,-32768,-32768,-32768,
-32768,   112,    87,-32768,   128,   130,   131,   132,   133,   -10,
    85,   127,-32768,-32768,-32768,-32768,   119,-32768,-32768,-32768,
-32768,-32768,-32768,   104,    87,-32768,-32768,   110,   120,   122,
   135,   124,   125,   140,    85,   141,   134,    27,-32768,   103,
-32768,-32768,   103,   131,-32768,   142,   103,-32768,   -12,   143,
   136,    85,   144,-32768,   137,    16,   145,   138,   126,-32768,
   139,-32768,   146,   147,-32768,   148,   149,   103,   151,-32768,
    85,   150,     6,    85,     6,   152,     6,-32768,   103,   153,
   155,   126,   156,   -13,   154,   159,-32768,   160,    -5,    30,
   157,     6,   103,    23,-32768,-32768,   158,   164,-32768,-32768,
   163,   170,   165,-32768,   172,-32768,     6,    40,   162,-32768,
   161,    -7,     0,   166,     7,-32768,-32768,-32768,-32768,-32768,
   175,-32768,    55,   176,-32768,     6,    -4,    -4,-32768,    -4,
-32768,    -4,-32768,-32768,   168,   179,-32768,-32768,   173,-32768,
-32768,-32768,-32768,-32768,-32768,   180,-32768,   178,   187,-32768
};

static const short yypgoto[] = {-32768,
     1,   202,-32768,-32768,   185,   186,-32768,    82,   -16,-32768,
   114,-32768,   115,   167,-32768,   188,  -113,   -78,    68,    95,
-32768,    56,   -83
};


#define	YYLAST		217


static const short yytable[] = {    42,
    46,   128,    49,   130,   101,    11,   135,   136,   104,    73,
    14,    12,   135,   136,   143,   135,   136,   137,   148,   135,
   136,    13,   105,    74,   124,   106,   150,   144,    50,   120,
   138,   168,     7,   163,    76,     1,   138,    27,   170,   138,
   131,   173,   150,   138,   125,   151,     1,   152,   153,   154,
   -68,    57,   179,   111,   149,     2,     3,    93,    90,    94,
   145,   151,   146,   152,   153,   154,     8,     9,   169,   171,
   164,    15,   165,     2,     3,   109,    16,    17,    18,    19,
    20,    21,    26,   180,   181,   176,   182,   177,   183,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,     8,     9,    47,    40,    52,    41,    95,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    62,
    15,    63,    96,    65,    41,    16,    17,    18,    19,    20,
    21,    64,    53,    34,    35,    36,    79,    80,    58,    34,
    35,    36,    82,    83,    60,    59,    61,    67,    77,    68,
    69,    71,    72,    78,    86,    84,    85,    87,    74,    88,
    91,   103,   107,   114,   112,   102,   110,   118,    92,   108,
   121,   -67,   113,   115,   129,   134,   116,   189,   122,    81,
   157,   117,   119,   123,   158,   159,   190,   132,   133,   141,
   142,   147,   160,   140,   162,   161,   166,   175,   178,   167,
   184,   185,   187,   186,   172,    10,    54,    55,   127,    56,
   174,     0,     0,     0,     0,     0,    75
};

static const short yycheck[] = {    16,
    17,   115,    19,   117,    83,     5,    20,    21,    87,    20,
    10,    31,    20,    21,    20,    20,    21,    31,   132,    20,
    21,     4,    35,    34,    19,    38,    20,    33,    20,   108,
    44,    39,    22,   147,    51,     3,    44,    34,    39,    44,
   119,    35,    20,    44,    39,    39,     3,    41,    42,    43,
    35,    20,   166,    38,   133,    23,    24,    31,    75,    33,
    31,    39,    33,    41,    42,    43,    23,    24,   152,   153,
    31,    20,    33,    23,    24,    92,    25,    26,    27,    28,
    29,    30,    22,   167,   168,    31,   170,    33,   172,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    23,    24,    34,    20,    34,    22,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    13,
    20,    13,    20,    37,    22,    25,    26,    27,    28,    29,
    30,    20,    32,    11,    12,    13,    33,    34,    16,    11,
    12,    13,    33,    34,    16,    32,    33,    20,    22,    20,
    20,    20,    20,    35,    20,    36,    35,    34,    34,    20,
    20,    20,    20,    38,    20,    84,    23,    20,    35,    34,
    20,    35,    35,    35,    23,    20,    31,     0,   111,    65,
    23,    35,    34,    34,    21,    23,     0,    35,    34,    31,
    31,    35,    23,    40,    23,    31,    35,    23,    23,    39,
    33,    23,    23,    31,    39,     4,    22,    22,   114,    22,
   155,    -1,    -1,    -1,    -1,    -1,    50
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 176 "parse.y"
{ ; ;
    break;}
case 2:
#line 177 "parse.y"
{ ; ;
    break;}
case 3:
#line 178 "parse.y"
{ ; ;
    break;}
case 4:
#line 179 "parse.y"
{ ; ;
    break;}
case 5:
#line 182 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 6:
#line 186 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 7:
#line 190 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 8:
#line 194 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 9:
#line 200 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 10:
#line 207 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 11:
#line 212 "parse.y"
{ ; ;
    break;}
case 12:
#line 213 "parse.y"
{ ; ;
    break;}
case 13:
#line 214 "parse.y"
{ ; ;
    break;}
case 14:
#line 215 "parse.y"
{ ; ;
    break;}
case 15:
#line 216 "parse.y"
{ ; ;
    break;}
case 16:
#line 217 "parse.y"
{ ; ;
    break;}
case 17:
#line 220 "parse.y"
{
			push_variable(yyvsp[-1].id,PUBLIC_SCOPE);
						;
    break;}
case 18:
#line 223 "parse.y"
{
			push_variable(yyvsp[-1].id,PRIVATE_SCOPE);
						;
    break;}
case 19:
#line 227 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-4].cbuf,yyvsp[-5].line,
						    yyvsp[-1].cbuf,yyvsp[-2].line);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-4].cbuf,yyvsp[-5].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 20:
#line 254 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,NULL,0);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,yyvsp[-1].cbuf,yyvsp[-2].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 21:
#line 278 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 22:
#line 279 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 23:
#line 282 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 24:
#line 285 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 25:
#line 291 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 26:
#line 295 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 27:
#line 302 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 28:
#line 305 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 29:
#line 308 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 30:
#line 311 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 31:
#line 314 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 32:
#line 317 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 33:
#line 320 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 34:
#line 323 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 35:
#line 326 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 36:
#line 329 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 37:
#line 333 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 38:
#line 336 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 39:
#line 341 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 40:
#line 344 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 41:
#line 347 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 42:
#line 350 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 43:
#line 353 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 44:
#line 358 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 45:
#line 361 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 46:
#line 364 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 47:
#line 369 "parse.y"
{ stars++; ;
    break;}
case 48:
#line 370 "parse.y"
{ stars++; ;
    break;}
case 49:
#line 373 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 50:
#line 378 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 51:
#line 381 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 52:
#line 387 "parse.y"
{
			int sigtype = SIGNAL_LAST_METHOD;
			if(strcmp(yyvsp[-9].id,"first")==0)
				sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-9].id,"last")==0)
				sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-9].id);
				YYERROR;
			}
			g_free(yyvsp[-9].id);

			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(sigtype,NULL,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-10].line,yyvsp[-1].line);
									;
    break;}
case 53:
#line 408 "parse.y"
{
			int sigtype = SIGNAL_LAST_METHOD;
			if(strcmp(yyvsp[-8].id,"first")==0)
				sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-8].id,"last")==0)
				sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-8].id);
				YYERROR;
			}
			g_free(yyvsp[-8].id);
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(sigtype, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, NULL,yyvsp[-9].line,0);
									;
    break;}
case 54:
#line 428 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-9].line,yyvsp[-1].line);
									;
    break;}
case 55:
#line 437 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, NULL,yyvsp[-8].line,0);
									;
    break;}
case 56:
#line 446 "parse.y"
{
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line);
									;
    break;}
case 57:
#line 450 "parse.y"
{
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, NULL,yyvsp[-7].line,0);
									;
    break;}
case 58:
#line 454 "parse.y"
{
			push_function(OVERRIDE_METHOD, yyvsp[-9].id,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-11].line,yyvsp[-1].line);
									;
    break;}
case 59:
#line 458 "parse.y"
{
			push_function(PUBLIC_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line);
								;
    break;}
case 60:
#line 462 "parse.y"
{
			push_function(PRIVATE_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line);
								;
    break;}
case 61:
#line 466 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(INIT_METHOD, NULL, yyvsp[-4].id, 
					      NULL, NULL,yyvsp[-3].line,0);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, NULL,yyvsp[-3].line,0);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 62:
#line 482 "parse.y"
{
			if(strcmp(yyvsp[-5].id,"init")==0) {
				push_init_arg(yyvsp[-3].id,FALSE);
				push_function(INIT_METHOD, NULL,
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line,
					      yyvsp[-1].line);
			} else if(strcmp(yyvsp[-5].id,"class_init")==0) {
				push_init_arg(yyvsp[-3].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL, 
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line,
					      yyvsp[-1].line);
			} else {
				g_free(yyvsp[-5].id);
				g_free(yyvsp[-3].id);
				g_string_free(yyvsp[-3].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 63:
#line 503 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 64:
#line 504 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 65:
#line 508 "parse.y"
{ ; ;
    break;}
case 66:
#line 509 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 67:
#line 514 "parse.y"
{ has_this = FALSE; ;
    break;}
case 68:
#line 515 "parse.y"
{
			has_this = TRUE;
			if(strcmp(yyvsp[0].id,"this")==0)
				push_this(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 69:
#line 525 "parse.y"
{
			has_this = TRUE;
			if(strcmp(yyvsp[-2].id,"this")==0)
				push_this(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 70:
#line 535 "parse.y"
{ has_this = FALSE; ;
    break;}
case 71:
#line 538 "parse.y"
{ ; ;
    break;}
case 72:
#line 539 "parse.y"
{ ; ;
    break;}
case 73:
#line 542 "parse.y"
{
			push_funcarg(yyvsp[0].id);
								;
    break;}
case 74:
#line 545 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id);
								;
    break;}
case 75:
#line 555 "parse.y"
{ ; ;
    break;}
case 76:
#line 556 "parse.y"
{ ; ;
    break;}
case 77:
#line 559 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 78:
#line 572 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 79:
#line 576 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 80:
#line 580 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 81:
#line 584 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 82:
#line 588 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 83:
#line 592 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 84:
#line 598 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 85:
#line 599 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 86:
#line 603 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 606 "parse.y"

